# frozen_string_literal: true

class Hermes::Api::Dmo::HousingRequestInitializersController < Hermes::Api::Dmo::ApplicationController
  VALID_OPERATORS = %w[$in $nin $ne $gt $gte $lt $lte $eq $regex $all]
  ACCEPTABLE_PARAMS = %w[
    unique_number
    pin_code_created_at
    email
    done
  ]

  def index
    acceptable_params *ACCEPTABLE_PARAMS
    valid_operators *VALID_OPERATORS

    aggregation = if !(['superadministrateur', 'collaborateur offre logement'] & current_user_roles).empty?
                    index_aggregation(no_acl: true)
                  else
                    index_aggregation
                  end

    paginate(
      aggregation,
      each_serializer: @serializer,
    )

  end
end