# frozen_string_literal: true

# checker Api::Dmo::HermesController avant d'ajouter des méthodes
class Hermes::Api::Dmo::ThresholdsController < Hermes::Api::Dmo::ApplicationController
  VALID_OPERATORS = %w[
    $in
    $nin
    $ne
    $gt
    $gte
    $lt
    $lte
    $regex
  ]

  ACCEPTABLE_PARAMS = %w[
    ids
    type
    codes
    thresholds_map
    housing_offer_ids
  ]

  REGEX_PARAMS = %w[
    type
    codes
  ]

  MUTATE_PARAMS = %i[
    type
    codes
    thresholds_map
  ]
        
  def mutate_params
    MUTATE_PARAMS
  end 


  def index
    acceptable_params *ACCEPTABLE_PARAMS
    regex_params *REGEX_PARAMS
    valid_operators *VALID_OPERATORS
    super
  end
end
