# frozen_string_literal: true

module Hermes
  module BoClient
    class SupplementRequestTask < BaseTask
      
      def initialize(options = {})
        @xsd = "complementDemandeImhoweb.xsd"
        @insee_code = options[:insee_code]
        super(options)
      end
      
      endpoint {'/ws/rest/als/demande/v1/complementDemandeImhoweb'}
      
      task_name 'application'
      type_flux 'BIEN'
      mapping 'Hermes::BoClient::Mappings::HousingRequestMap'
      
      params *%i[
      ]
      
      def to_xml
        namespaces = {
          'xmlns:ns2' => "http://v1.als.ikos.webservice.immobilier.sopra/demande/complementDemandeImhoweb"
        }
        
        builder = Nokogiri::XML::Builder.new(encoding: 'UTF-8') do |b|
          b['ns2'].complement_demande_imhoweb(namespaces) do
            b.numUnique mapping.numUnique do
              b.parent.namespace = nil
            end

            if @insee_code            
              b.codeInseeInstruction @insee_code do
                b.parent.namespace = nil
              end
            end 
          end
        end
        
        builder.to_xml
      end
    end
  end
end
