raise 'You need to load this script througth a require' unless __FILE__
# Replace following variables if need
FILE_TYPE = 'csv'
FILE_PATH = "."

def file_log(file, line)
  file << line
  puts line.join(', ')
end 

def run_script(skip)
  start_time = Time.now
  formated_t = start_time.strftime('%Y-%m-%d-%H:%M')
  puts "Start script at #{start_time}"
  file_name   = "#{HERMES_CONFIG['environment']}-#{formated_t}-#{__FILE__.split('/').last.gsub('.rb', ".#{FILE_TYPE}")}"
  file_class  = FILE_TYPE == 'csv' ? CSV : File
  file        = file_class.open("#{FILE_PATH}/#{file_name}", 'ab')
  ##############################################################################
  ##################################__SCRIPT__##################################
  # write the content of the script bellow
  file << [
    "housing offer_id",
    "external_ref",
    "als_id",
    "old_offer_status",
    "old_lessor_status",
    "offer_status",
    "lessor_status",
    "action",
  ]

  table = CSV.parse(File.read("Export_ARC_ajout.csv"), headers: true, col_sep:  ";" )
  count = table.length

  table.each_with_index do |row, i|
    begin
      puts "#{i}/#{count}"

    
      o = Hermes::HousingOffer.find(row["REFALS"])
      old_offer_status = o.offer_status
      old_lessor_status = o.lessor_status

      o.offer_status = "ARCHIVE"
      o.lessor_status = "RETIRE"

      # debut ligne à commenter pour mode sans modif
      o.set(
        updated_at: DateTime.now,
        offer_status: "ARCHIVE",
        lessor_status: "RETIRE"
      )
      # fin ligne à commenter pour mode sans modif

      action = "udpated statuses"

      line = [
        o.id,
        o.external_ref,
        o.als_id,
        old_offer_status,
        old_lessor_status,
        o.offer_status,
        o.lessor_status,
        action,
      ]

      file_log(file, line)

    rescue Exception => e
      line = [row["REFALS"], "Erreur de traitement: #{e}\n"]
      file_log(file, line)
    end
  end

  ##############################################################################
  ##############################################################################
  file.close
  stop_time = Time.now
  puts "Start end at #{stop_time}"
  puts "Executed in #{(stop_time - start_time).seconds}"
  puts "Filename: #{file_name}"
end
run_script(0)